/* A program illustrating the birthday paradox - not that many people have
 * to be in a room for at least two of them to have the same birthday.
 */
import acm.program.*;
import acm.util.*;

public class HappyBirthday extends ConsoleProgram {
	/* Number of days in the year.  We'll include leap years. */
	private static final int NUM_DAYS = 366;

	public void run() {
		int numPeople = 0;
		
		/* Track which birthdays have been used so far. */
		boolean[] usedDays = new boolean[NUM_DAYS];
		
		while (true) {
			numPeople++;
			
			RandomGenerator rgen = RandomGenerator.getInstance();
			int birthday = rgen.nextInt(0, NUM_DAYS - 1);
			
			/* If we've seen this birthday, we're done. Otherwise, mark it as used. */
			if (usedDays[birthday]) break;
			usedDays[birthday] = true;
		}
		
		println("We needed " + numPeople + " people to get two people with the same birthday.");
	}
}
